#ifndef __config_included
#define __config_included

#include <stdio.h>

#ifdef __BORLANDC__
#if defined(_M_IX86)
#define MACHINE "Intel"
#elif defined(_M_ALPHA)
#define MACHINE "Alpha"
#elif defined(_M_PPC) || defined(_M_MPPC)
#define MACHINE "PowerPC"
#elif defined(_M_MRX000)
#define MACHINE "Mips"
#elif defined(_M_M68K)
#define MACHINE "M68K"
#endif

#define NEARSTR "%s(%d):"
#define NEARPOS __FILE__, __LINE__
#define PLATFORM "(Unknown) " MACHINE
#define COMPILER "BC"
#define CVERSION (__BORLANDC__ / 100), (__BORLANDC__ % 100)
#define DL_API(type) type __export
#endif /* __BORLANDC__ */

#ifdef _MSC_VER
#include <process.h>
#pragma warning(disable:4702) /* Unreachable code */
#pragma warning(disable:4711) /* Function '%s' selected for automatic inline expansion */
#pragma warning(disable:4001) /* Single line comment */
#pragma warning(disable:4056) /* overflow in floating-point constant arithmetic */

#if defined(_M_IX86)
#define MACHINE "Intel"
#elif defined(_M_ALPHA)
#define MACHINE "Alpha"
#elif defined(_M_PPC) || defined(_M_MPPC)
#define MACHINE "PowerPC"
#elif defined(_M_MRX000)
#define MACHINE "Mips"
#elif defined(_M_M68K)
#define MACHINE "M68K"
#endif

#define NEARSTR "%s(%d):"
#define NEARPOS __FILE__, __LINE__
#define PLATFORM "Win32 " MACHINE
#define COMPILER "MSC32"
#define CVERSION (_MSC_VER / 100), (_MSC_VER % 100)
#define DL_API(type) __declspec(dllexport) type
#endif /* _MSC_VER */

#ifdef __GNUC__
#define NEARSTR "%s(%d)[%s]:"
#define NEARPOS __FILE__, __LINE__, __FUNCTION__
#define PACKED __attribute__((packed))
#define PLATFORM GNUSYSTEM
#define COMPILER "GNU CC"
#define CVERSION __GNUC__, __GNUC_MINOR__
#define GNUSYSTEM "Linux i586"

#if defined(__CYGWIN32__) && defined(_WIN32)
#define DL_API(type) __declspec(dllexport) type
#else
#define DL_API(type) extern type
#endif

#else
#define PACKED
#endif /* __GNUC__ */

#define _CHECK(cond, msg, p0, p1) (void) ((cond) ? \
(fprintf(stderr, NEARSTR " %s, " msg, NEARPOS, #cond, p0, p1), \
fflush(stderr), \
perror("\nsystem message"),\
exit(2), 0) \
: (0))

#define uint unsigned int
#define uchar unsigned char
#define ushort unsigned short
#define ulong unsigned long

#endif /* __config_included */
